#README

## General Information
***
This program simulates the Kocher timing attack with different timing models. A timeanalyzer attacks the private key of the subject, which performs RSA decryption with different messages.


## Prerequisite
***
* SystemC
* The standard GNU C++ compiler 'g++'
* A LaTeX distribution (for example TeX Live)


## Installation
***
1. Adjust the path for SYSTEMC_HOME in the Makefile to your system
2. Adjust the path where the results should be stored (in the file constants.h)
3. Start the compilation process with the following command: ```$ make ```
4. After a successful compilation, the program can be executed with: ```$ ./main ```
5. Sometimes LaTeX is reaching its memory limit. Then, the variables main_memory and extra_mem_top in texmf.cnf must be increased.
    * In case of texlive the path is /usr/share/texlive/texmf-dist/web2c/texmf.cnf


## Operations Manual
***
The whole program can be controlled by the file constants.h where parameters are also explained. In the following, we would like to emphasize the two most important setting options.

* The attack can simulate either 1 bit or two bits to guess a bit of the private key. For this purpose, the parameter GUESSBITS is set to 1 or 2.
* There are four different time models that can be set. The numbers 1 to 4 are valid inputs. Most time consumption is caused by the multiplication, whose time depends on the following quantity.
    * Variant 1: only on the highest significant bit of x and it depends not on the intermediate values s (only for 1 bit guess available)
    * Variant 2: on the highest significant bit also for the intermediate values s
    * Variant 3: on number of bits during calculation
    * Variant 4: on the calculation effort for the Booth algorithm (only for 2 bits guess available)


## Further information
***
* The program has only been tested under Ubuntu 18.04 with SystemC Version 2.3.3
* During execution, the command line displays whether the key currently being viewed was guessed wrong or right. The key is displayed in decimal notation and the following 0 or 1 indicates whether the key was guessed wrong or right.
* In order to execute the program again with changed entries in constants.h, the command ```$ make && ./main``` is sufficient.